{-# LANGUAGE DataKinds              #-}
{-# LANGUAGE FlexibleContexts       #-}
{-# LANGUAGE ScopedTypeVariables    #-}
{-# LANGUAGE TypeFamilies           #-}
{-# LANGUAGE TypeFamilyDependencies #-}
{-# LANGUAGE TypeOperators          #-}
{-# LANGUAGE UndecidableInstances   #-}
module Data.FixedWidth.Shared (bitWidth, byteWidth) where

import           Data.Proxy
import           Data.Type.Bool
import           GHC.TypeLits

bitWidth :: KnownNat n => fixed n -> Int
bitWidth = fromIntegral . natVal

byteWidth :: forall fixed n. (KnownNat (BitsToBytes n)) => fixed n -> Int
byteWidth _ = fromIntegral . natVal $ (Proxy :: Proxy (BitsToBytes n))

type family BitsToBytes bits where
    BitsToBytes 8 = 1
    BitsToBytes 16 = 2
    BitsToBytes 24 = 3
    BitsToBytes 32 = 4
    BitsToBytes 40 = 5
    BitsToBytes 48 = 6
    BitsToBytes 56 = 7
    BitsToBytes 64 = 8
    BitsToBytes 256 = TypeError (Text "Bit numbers larger than 64 not implemented.")
    BitsToBytes n = BitsToBytes (n + 1)
